var express = require('express');
var path = require('path');
var favicon = require('serve-favicon');
var logger = require('morgan');
var cookieParser = require('cookie-parser');
var bodyParser = require('body-parser');
var serveIndex = require('serve-index');

//some setttings
var pjson = require('./package.json');

var routes = require('./routes/index');
var users = require('./routes/users');

var app = express();

// module.exports = require('./app/app.js');
var run = pjson.scripts.start;

// Take the argument 
var argument = process.argv[2];
var nothelp = 'use argument help';

if (argument === 'help' || argument === 'h' || argument === '-h') {
    //fetch help variables file
    require('./lib/help.js');
  } if (argument === false) {
    console.log(nothelp);
 }

// view engine setup
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'jade');

app.use(logger('dev'));
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, 'public')));
/* Index images from public upload folder*/
app.use('/img/upload', serveIndex('public/img/upload', {'icons': false}));

app.use('/', routes);
app.use('/users', users);

// catch 404 and forward to error handler
app.use(function(req, res, next) {
    var err = new Error('Not Found');
    err.status = 404;
    next(err);
});

// error handlers

// development error handler
// will print stacktrace
if (app.get('env') === 'development') {
    app.use(function(err, req, res, next) {
        res.status(err.status || 500);
        res.render('error', {
            message: err.message,
            error: err
        });
    });
}

// production error handler
// no stacktraces leaked to user
app.use(function(err, req, res, next) {
    res.status(err.status || 500);
    res.render('error', {
        message: err.message,
        error: {}
    });
});


module.exports = app;
